#include "..//my_header.h"

int main()
{
    printf("i am parent %u\n", getpid());

    char path_file[] = "..//file.txt"; // путь к файлу

    // открыл файл. почему то работает только в этом моде
    int fd = open(path_file, O_RDONLY);
    char *buffer = (char *)calloc(1, 100);
    read(fd, buffer, 100); // запись

    pid_t some_pid, current; // создал пиды

    switch (some_pid = fork())
    {
    case -1:
        // there is error
        perror("Error");
        exit(1);
        break;

    case 0:;
        // выполняется только дочерняя инструкция
        char *buffer_fd = (char *)calloc(1, 100);
        sprintf(buffer_fd, "%d", fd);
        char *child_argv[] = {buffer, buffer_fd, NULL};
        // создал аргументы, чтобы передать в скомпилированный файл child.
        // Принцип похож, что мы к запускаем: "./child {arguments...}"

        execve("child", child_argv, NULL);
        // завершится наш процесс с исходным кодом внутри result как в child
        break;

    default:;
        // выполняется у родительского процесса

        int status;
        // ! такой вариант дождётся завершения программы
        some_pid = wait(&status); // вернул в status указатель на код

        // ! такой почему то не дожидается и идёт дальше
        // some_pid = waitpid(some_pid, &status, WNOHANG);
        // status = WEXITSTATUS(status);

        // printf("status %d\n", status);

        switch (WEXITSTATUS(status)) // WEXITSTATUS забирает по указателю код
        {
        case 0:
            printf("there is no solution\n");
            break;

        case 1:
            printf("there is only one solution:\n");
            print_that_one();
            break;

        case 2:
            printf("there are two solutions:\n");
            print_that_one();
            break;

        default:
            printf("Huston we got problems\n");
            break;
        }
        break;
    }

    return 0;
}



void print_that_one()
{
    int new_fd = open("otvet.txt", O_RDONLY);
    char *new_buffer = (char *)calloc(1, 300);
    read(new_fd, new_buffer, 300);

    printf("%s", new_buffer);

    close(new_fd);
}